<?php
/**
 * Class to display paginated results from sql queries with extra functions
 * @author José Carlos Cruz Parra AKA internia
 * josecarlos@programadorphpfreelance.com
 * http://programadorphpfreelance.com
 * 2008-2009-2010-2011-2012
 * This code is released under the GNU General Public License.
 */

require_once("SqlSelectQuery.class.php");

class DB_Paginador
{
	var $desde = 0;
	var $max_regs = 25;
	var $total_regs = 0;
	var $query = "";
	var $campos = array();
	var $regs = array();
	var $num_regs = 0;
	/**
	 * @var DB_Connection
	 */
	var $db_con = null;
	var $method = "get";
	var $key = 0;
	var $completarConVacios = false;
	var $usarImg = true;
	var $img_dir = "images/";
	var $img_orderASC_off = "orderASC_off.gif";
	var $img_orderASC_on = "orderASC_on.gif";
	var $img_orderDESC_off = "orderDESC_off.gif";
	var $img_orderDESC_on = "orderDESC_on.gif";
	var $img_anterior = "pag_anterior.gif";
	var $img_siguiente = "pag_siguiente.gif";
	var $img_primera = "pag_primera.gif";
	var $img_ultima = "pag_ultima.gif";
	var $img_buscar = "shell/view16.gif";
	var $txt_orderASC = "&uarr;";
	var $txt_orderDESC = "&darr;";
	var $title_orderASC;
	var $title_orderDESC;
	var $txt_anterior;
	var $txt_siguiente;
	var $txt_primera;
	var $txt_ultima;
	var $titulo = "";
	var $formato_tabla = array("style"=>"margin:0px auto;text-align:left");
	var $etiqueta;
	var $mostraretiqueta = true;
	var $onclick = "";
	var $tr_title;
	var $orderBy = "";
	var $permitirOrdenacion = true;
	var $applyToRegs = "";
	var $buscador = false;
	var $filtro_campo = "";
	var $filtro_valor = "";
	var $filtro_exacto = false;
	var $input_valor_size = 12;
	var $mostrarTotales = false;
	var $totales = array();
	var $action = "index.php";
	var $language = "ES";
	var $etiquetasbuscar = null;
	var $tr_class_especiales = array();
	var $previoHTML = '';
	var $extraHTML = '';
	/**
	 * Constructor
	 *
	 * @param int $max_regs
	 * @param DB_Connection $db_con
	 * @return DB_Paginador
	 */
	function DB_Paginador($max_regs=25, $db_con=null)
	{
		$this->max_regs = $max_regs;
		$this->db_con = $db_con == null ? DB_Connection::Factory() : $db_con;
		$this->key = mt_rand(0, 100000);

		$this->title_orderASC = _("Orden ascendente");
		$this->title_orderDESC = _("Orden descendente");
		$this->txt_anterior = _("Anterior");
		$this->txt_siguiente = _("Siguiente");
		$this->txt_primera = _("Primera");
		$this->txt_ultima = _("Última");
		$this->etiqueta = _("resultado");
		$this->tr_title = _("Seleccionar...");
		$this->etiquetasbuscar = array(
			"buscar"=>_("Buscar"),
			"convalor"=>_("con valor"),
			"exacto"=>_("exacto")
			);
	}

	function Fill($from="")
	{
		if(is_array($from))
		{
			$this->FillFromArray($from);
		}
		else
		{
			$this->FillFromQuery($from);
		}
	}
	function FillFromQuery($query="")
	{
		$request = $this->method == "post" ? $_POST : $_GET;

		if($query != "")
		{
			$this->query = $query;
		}
		$ssq = new SqlSelectQuery($this->query);
		$contenidoSelect = $ssq->GetContenidoComponente("SELECT");
		$modifiersSelect = $ssq->GetModifiersComponente("SELECT");
		$ssq->SetComponente("SELECT", "1", ""); //Para la consulta del total
		$ssq->SetContenidoComponente("LIMIT", "");
		//Filtro
		$this->filtro_campo = (isset($request["filtro_campo"]) && $request["filtro_campo"]) ? $request["filtro_campo"] : false;
		$this->filtro_valor = (isset($request["filtro_valor"])) ? $request["filtro_valor"] : false;
		$this->filtro_exacto = (isset($request["filtro_exacto"]) && $request["filtro_exacto"]);
		if($this->filtro_campo !== false && (strlen($this->filtro_valor) > 0 || $this->filtro_exacto))
		{
			$where = $ssq->GetContenidoComponente("WHERE");
			$filtro = $this->filtro_exacto ? "= REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(LOWER('{$this->filtro_valor}'),'á','a'),'é','e'),'í','i'),'ó','o'),'ú','u'),',','.')" : "LIKE REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(LOWER('%{$this->filtro_valor}%'),'á','a'),'é','e'),'í','i'),'ó','o'),'ú','u'),',','.')";
			$ssq->SetContenidoComponente("WHERE", ($where == "" ? "" : "{$where} AND")." REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(LOWER({$this->filtro_campo}),'á','a'),'é','e'),'í','i'),'ó','o'),'ú','u') {$filtro}");
		}

		$this->total_regs = $this->db_con->GetCount($ssq->BuildQuery());
		if($this->max_regs == 0)
		{
			$this->max_regs = $this->total_regs;
		}
		if($this->total_regs > 0)
		{
			//Ordenación
			$this->orderBy = (isset($request["por"]) && $request["por"]) ? $request["por"]." ".$request["modo"] : "";
			$order = $ssq->GetContenidoComponente("ORDER BY");
			if($this->orderBy != "")
			{
				$ssq->SetContenidoComponente("ORDER BY", $order == "" ? $this->orderBy : $this->orderBy.",".$order);
			}

			//Desde
			$this->Desde();
			$ssq->SetContenidoComponente("LIMIT", "{$this->desde}, {$this->max_regs}");

			//Obtener regs
			$ssq->SetComponente("SELECT", $contenidoSelect, $modifiersSelect); //Restauramos el select
			$this->regs = $this->db_con->GetRows($ssq->BuildQuery());
		}
		$this->num_regs = sizeof($this->regs);

		if($this->mostrarTotales)
		{
			$ssq->SetContenidoComponente("LIMIT", "");
			$ssq->SetContenidoComponente("ORDER BY", "");
			$this->totales = array();
			for($c=0,$size=sizeof($this->campos); $c<$size; $c++)
			{
				if(!$this->campos[$c]["hidden"])
				{
					if($this->campos[$c]["total"])
					{
						$ssq->SetContenidoComponente("SELECT", $this->campos[$c]["total"]);
						$this->totales[$c] = $this->db_con->GetValueQuery($ssq->BuildQuery());
					}
					else
					{
						$this->totales[$c] = false;
					}
				}
			}
		}
	}
	/**
	 * Llena el paginador a partir del array pasado como argumento en vez de desde la consulta $this->query
	 * El array pasado tiene que ser un array de arrays asociativos (a modo de registros).
	 * @param array $array
	 */
	function FillFromArray($array)
	{
		$this->total_regs = sizeof($array);
		if($this->total_regs > 0)
		{
			//Ordenación
			$request = $this->method == "post" ? $_POST : $_GET;
			if(isset($request["por"]) && $request["por"])
			{
				$por = array();
				foreach($array as $key => $row)
				{
					if(isset($row[$request["por"]]))
					{
						$por[$key]  = $row[$request["por"]];
					}
				}
				array_multisort($por, $request["modo"] == "DESC" ? SORT_DESC : SORT_ASC, $array);
			}

			//Desde
			$this->Desde();

			//Obtener regs
			$keys = array_keys($array);
			$size = $this->max_regs > 0 ? $this->desde + $this->max_regs : $this->total_regs - $this->desde;
			for($c=$this->desde; $c<$size; $c++)
			{
				if(isset($keys[$c]) && isset($array[$keys[$c]]))
				{
					$this->regs[] = $array[$keys[$c]];
				}
			}
		}
		$this->num_regs = sizeof($this->regs);
	}
	function AddReg($array)
	{
		$this->regs[] = $array;
		$this->num_regs++;
	}
	/**
	 * Si se ha asignado, aplica la función de usuario con el nombre $this->applyToReg
	 * a cada uno de los registros del listado
	 *
	 * @param string $function
	 */
	function Regs_Walk()
	{
		if($this->applyToRegs != "")
		{
			array_walk($this->regs, $this->applyToRegs, $this); //Antes de 2009-01-17 el tercer parámetro era $this->num_regs);
		}
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 * para completar con registros vacíos hasta el número de registros por página
	 * (si está activado y es necesario)
	 *
	 */
	function CompletarConVacios()
	{
		if($this->completarConVacios)
		{
			//Completamos con registros vacíos hasta el número máximo de registros por página
			for($c=sizeof($this->regs),$size=$this->max_regs; $c<$size; $c++)
			{
				$this->regs[$c] = array();
				$keys = array_keys($this->regs[0]);
				for($k=0, $size2=sizeof($keys); $k < $size2; $k++)
				{
					$this->regs[$c][$keys[$k]] = "&nbsp;";
				}
			}
		}
	}
	/**
	 * Private
	 * Para determinar el valor de desde
	 *
	 */
	function Desde()
	{
		$request = $this->method == "post" ? $_POST : $_GET;
		$this->desde = (isset($request["desde"]) && is_numeric($request["desde"]) && $request["desde"] >= 0) ? $request["desde"] : 0;

		if($this->desde > ($this->total_regs - 1))
		{
			$this->desde = ($this->total_regs - $this->max_regs);
		}
		if($this->desde < 0)
		{
			$this->desde = 0;
		}
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 * para crear las cabeceras de las columnas
	 *
	 */
	function CompletarCampos()
	{
		if(is_array($this->regs[0]))
		{
			$fields = array_keys($this->regs[0]);
			$fields_size = sizeof($fields);
			if(!is_array($this->campos))
			{
				$this->campos = array();
			}
			for($c=0; $c<$fields_size; $c++)
			{
				if(!isset($this->campos[$c]))
				{
					$this->campos[$c] = array("label"=>$fields[$c], "orderby"=>$fields[$c]);
				}
				elseif(!isset($this->campos[$c]["orderby"]) || $this->campos[$c]["orderby"] === true)
				{
					$this->campos[$c]["orderby"] = $fields[$c];
				}
			}
		}
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @return array
	 */
	function GetRequested()
	{
		$request = $this->method == "post" ? $_POST : $_GET;
		$keys = array_keys($request);
		$requested = array();
		for($c=0,$size=sizeof($request); $c<$size; $c++)
		{
			$name = $keys[$c];
			//Desechamos rehacer operaciones (reg, upd, del,...)
			if($name != "op")
			{
				$requested[] = array("name"=>$name, "value"=>$request[$name]);
			}
		}
		if(!in_array("filtro_campo", $keys))
		{
			$requested[] = array("name"=>"filtro_campo", "value"=>$this->filtro_campo);
		}
		if(!in_array("filtro_valor", $keys))
		{
			$requested[] = array("name"=>"filtro_valor", "value"=>$this->filtro_valor);
		}
		if(!in_array("filtro_exacto", $keys))
		{
			$requested[] = array("name"=>"filtro_exacto", "value"=>$this->filtro_exacto);
		}
		if(!in_array("desde", $keys))
		{
			$requested[] = array("name"=>"desde", "value"=>$this->desde);
		}
		if(!in_array("por", $keys))
		{
			$requested[] = array("name"=>"por", "value"=>"");
			$requested[] = array("name"=>"modo", "value"=>"");
		}
		return $requested;
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @param string $campo_orderby
	 * @return string
	 */
	function GetOrderASC($campo_orderby)
	{
		$orderBy = explode(" ", $this->orderBy);
		$activo = ($orderBy[0] == $campo_orderby && $orderBy[1] == "ASC");
		return $this->usarImg ?
			"<img src=\"{$this->img_dir}".($activo ? $this->img_orderASC_on : $this->img_orderASC_off)."\" alt=\"{$this->txt_orderASC}\" title=\"{$this->title_orderASC}\" />"
			:
			$this->txt_orderASC;
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @param string $campo_orderby
	 * @return string
	 */
	function GetOrderDESC($campo_orderby)
	{
		$orderBy = explode(" ", $this->orderBy);
		$activo = ($orderBy[0] == $campo_orderby && $orderBy[1] == "DESC");
		return $this->usarImg ?
			"<img src=\"{$this->img_dir}".($activo ? $this->img_orderDESC_on : $this->img_orderDESC_off)."\" alt=\"{$this->txt_orderDESC}\" title=\"{$this->title_orderDESC}\" />"
			:
			$this->txt_orderDESC;
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @return string
	 */
	function GetAnterior()
	{
		return $this->usarImg ? "<img src=\"{$this->img_dir}{$this->img_anterior}\" alt=\"{$this->txt_anterior}\" />" : $this->txt_anterior;
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @return string
	 */
	function GetSiguiente()
	{
		return $this->usarImg ? "<img src=\"{$this->img_dir}{$this->img_siguiente}\" alt=\"{$this->txt_siguiente}\" />" : $this->txt_siguiente;
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @return string
	 */
	function GetPrimera()
	{
		return $this->usarImg ? "<img src=\"{$this->img_dir}{$this->img_primera}\" alt=\"{$this->txt_primera}\" />" : $this->txt_primera;
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @return string
	 */
	function GetUltima()
	{
		return $this->usarImg ? "<img src=\"{$this->img_dir}{$this->img_ultima}\" alt=\"{$this->txt_ultima}\" />" : $this->txt_ultima;
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @return string
	 */
	function GetEtiqueta()
	{
		if($this->total_regs == 1)
		{
			return $this->etiqueta;
		}
		else
		{
			return Pluralizador::Plural($this->etiqueta, true, $this->language);
		}
	}
	/**
	 * Sólo se usa desde paginador.tpl, plantilla genérica complemento de esta clase y que no hay que tocar
	 *
	 * @return int
	 */
	function GetNumPaginas()
	{
		$div = $this->total_regs / $this->max_regs;
		$val = intval($div);
		return  $div > $val ? $val + 1 : $val;
	}
	/**
	 * Establece el idioma y de paso pone las etiquetas en ese idioma.
	 * Idiomas admitidos: ES, EN
	 *
	 * @param string $language
	 */
	function SetLanguage($language)
	{
		$this->language = strtoupper($language);
		switch($this->language)
		{
			case "ES":
				$this->etiquetasbuscar = array(
					"buscar"=>"Buscar",
					"convalor"=>"con valor",
					"exacto"=>"exacto"
					);
				$this->title_orderASC = "Orden ascendente";
				$this->title_orderDESC = "Orden descendente";
				break;
			case "EN":
				$this->etiquetasbuscar = array(
					"buscar"=>"Search",
					"convalor"=>"with value",
					"exacto"=>"exact"
					);
				$this->title_orderASC = "Order asc.";
				$this->title_orderDESC = "Order desc.";
				break;
		}
	}
}
?>