<?php
/**
 * Class to encode/decode strings
 * @author José Carlos Cruz Parra AKA internia
 * josecarlos@programadorphpfreelance.com
 * http://programadorphpfreelance.com
 * 2008-2012
 * This code is released under the GNU General Public License.
 */
class MyCoder
{
	/**
	 * private
	 *
	 * @param int $var
	 * @return string
	 */
	private static function Cod2Op($var)
	{
		switch($var)
		{
			case 0: case 2: case 5:
				$var = "s";
				break;
			case 1: case 4: case 7:
				$var = "r";
				break;
			case 3: case 6: case 8:
				$var = "m";
				break;
			case 9:
				$var = "d";
				break;
			default:
				die("Error MyCoder::Cod2Op $var");
		}
		return $var;
	}
	/**
	 * private
	 *
	 * @param int $var
	 * @return int
	 */
	private static function Fake2Len($var)
	{
		switch($var)
		{
			case 0: case 2: case 5:
				$var = 2;
				break;
			case 1: case 4: case 7:
				$var = 3;
				break;
			case 3: case 6: case 8:
				$var = 4;
				break;
			case 9:
				$var = 1;
				break;
			default:
				die("Error MyCoder::Fake2Len $var");
		}
		return $var;
	}
	/**
	 * private
	 *
	 * @param int $var
	 * @return int
	 */
	private static function Len2Fake($var)
	{
		switch($var)
		{
			case 1:
				$var = "9";
				break;
			case 2:
				$var = "025";
				break;
			case 3:
				$var = "147";
				break;
			case 4:
				$var = "368";
				break;
			default:
				die("Error MyCoder::Len2Fake $var");
		}
		return $var[mt_rand(0, strlen($var)-1)];
	}
	/**
	 * Codifica mediante un algoritmo propio
	 *
	 * @param string $str
	 * @return string
	 */
	public static function Encode_my($str)
	{
		$strlen = strlen($str);
		$lenlen = MyCoder::Len2Fake(strlen($strlen));
		$fakes = mt_rand(0,9);
		$result = $lenlen.$strlen.$fakes;

		$fakes = MyCoder::Fake2Len($fakes);
		for($i=0; $i<$strlen; $i++)
		{
			$ascii = ord($str[$i]);
			$op = mt_rand(0,9);
			switch(MyCoder::Cod2Op($op))
			{
				case "s":
					$x = $ascii > 247 ? mt_rand(4,255-$ascii) : mt_rand(4,8);
					$ascii += $x;
					break;
				case "r":
					$x = $ascii < 8 ? mt_rand(0,$ascii) : mt_rand(4,8);
					$ascii -= $x;
					break;
				case "m":
					$x = mt_rand(1,3);
					$ascii *= $x;
					break;
				case "d":
					$x = ($ascii % 2 == 0) ? 2 : mt_rand(3,9);
					if($x == 2)
					{
						$ascii /= $x;
					}
					break;
			}
			$asciilen = strlen($ascii);
			$fake = MyCoder::Len2Fake($asciilen);
			while(strlen($ascii) < 3)
			{
				$ascii = mt_rand(0,9).$ascii;
			}
			for($c=0; $c<$fakes; $c++)
			{
				$ascii .= mt_rand(0,9);
			}
			$result .= ($op.$x.$fake.$ascii);
		}
		while(strlen($result) < 160)
		{
			$result .= mt_rand(0,9);
		}
		return $result;
	}
	/**
	 * Descodifica una cadena previamente codificada mediante algoritmo propio
	 *
	 * @param string $str
	 * @return string
	 */
	public static function Decode_my($str)
	{
		$lenlen = MyCoder::Fake2Len($str[0]);
		$strlen = substr($str, 1, $lenlen);
		$fakes = MyCoder::Fake2Len(substr($str, 1+$lenlen, 1));
		$num = 6 + $fakes;
		$preresult = substr($str, 2+$lenlen, $num*$strlen);
		$result = "";
		for($c=0; $c<$strlen; $c++)
		{
			$item = substr($preresult, 0, $num);
			$op = substr($preresult, 0, 1);
			$x = substr($preresult, 1, 1);
			$ndig = MyCoder::Fake2Len(substr($item,2,1));
			$ascii = substr($item, 6-$ndig, $ndig);
			switch(MyCoder::Cod2Op($op))
			{
				case "s":
					$ascii -= $x;
					break;
				case "r":
					$ascii += $x;
					break;
				case "m":
					$ascii /= $x;
					break;
				case "d":
					if($x == 2)
					{
						$ascii *= $x;
					}
					break;
			}
			$result .= chr($ascii);
			$preresult = substr($preresult, $num);
			$item.$preresult;
		}
		return $result;
	}

	public static function SecureFileName($str)
	{
		$str = str_replace(" ", "_", $str);
		$str = str_replace("ñ", "n", $str);
		$str = str_replace("Ñ", "N", $str);
		$str = str_replace("á", "a", $str);
		$str = str_replace("é", "e", $str);
		$str = str_replace("í", "i", $str);
		$str = str_replace("ó", "o", $str);
		$str = str_replace("ú", "u", $str);
		$str = str_replace("à", "a", $str);
		$str = str_replace("è", "e", $str);
		$str = str_replace("ì", "i", $str);
		$str = str_replace("ò", "o", $str);
		$str = str_replace("ù", "u", $str);
		$str = str_replace("ä", "a", $str);
		$str = str_replace("ë", "e", $str);
		$str = str_replace("ï", "i", $str);
		$str = str_replace("ö", "o", $str);
		$str = str_replace("ü", "u", $str);
		$str = str_replace("Á", "A", $str);
		$str = str_replace("É", "E", $str);
		$str = str_replace("Í", "I", $str);
		$str = str_replace("Ó", "O", $str);
		$str = str_replace("Ú", "U", $str);
		$str = str_replace("À", "A", $str);
		$str = str_replace("È", "E", $str);
		$str = str_replace("Ì", "I", $str);
		$str = str_replace("Ò", "O", $str);
		$str = str_replace("Ù", "U", $str);
		$str = str_replace("Ä", "A", $str);
		$str = str_replace("Ë", "E", $str);
		$str = str_replace("Ï", "I", $str);
		$str = str_replace("Ö", "O", $str);
		$str = str_replace("Ü", "U", $str);

		return MyCoder::Clean($str, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789._-+()[]{}");
	}

	public static function EncodeFileName($str)
	{
		$ret = "";
		for($c=0,$size=strlen($str); $c<$size-1; $c++)
		{
			$ret .= ord($str[$c]).".";
		}
		$ret .= ord($str[$c]);
		$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUWXYZ";
		for($c=0,$size=strlen($chars); $c<$size; $c++)
		{
			$char = $chars[$c];
			$ret = str_replace(".".ord($char), $char, $ret);
			$ret = str_replace(ord($char), $char, $ret);
		}
		$ret = str_replace(".32", "_", $ret);
		return $ret;
	}

	public static function DecodeFileName($str)
	{
		$str = str_replace("_", ".32", $str);
		$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUWXYZ";
		for($c=0,$size=strlen($chars); $c<$size; $c++)
		{
			$char = $chars[$c];
			$str = str_replace($char, ".".ord($char), $str);
		}
		$ret = "";
		$tok = strtok($str, ".");
		while($tok !== false)
		{
			$ret .= chr($tok);
			$tok = strtok(".");
		}
		return $ret;
	}
	/**
	 * Elimina de una cadena todos los caracteres que no se encuentran en el filtro
	 *
	 * @param string $str
	 * @param string $filter
	 * @return string
	 */
	public static function Clean($str, $filter)
	{
		$strFormatted = "";
		$len = strlen($str);
		for($c=0; $c < $len; $c++)
			if(!(strpos($filter, $str[$c]) === false))
				$strFormatted .= $str[$c];
		return $strFormatted;
	}
	/**
	 * Purpose:  encodes a string in hex (useful for email address)
	 * @param string $str
	 * @return string
	 */
	public static function Encode_hex($str)
	{
	    $str_encode = '';
	    for ($x=0; $x < strlen($str); $x++) {
	        if(preg_match('!\w!',$str[$x])) {
	            $str_encode .= '%' . bin2hex($str[$x]);
	        } else {
	            $str_encode .= $str[$x];
	        }
	    }
	    return $str_encode;
	}

	public static function Encode($str, $key)
	{
		return bin2hex(MyCoder::Encode_simple($str, $key));
	}

	public static function Decode($str, $key)
	{
		return MyCoder::Encode_simple(MyCoder::hex2bin($str), $key);
	}

	private static function Encode_simple($data, $pwd)
	{
	    $pwd_length = strlen($pwd);
	    $key = array();
	    $counter = array();

	    for($i = 0; $i < 255; $i++)
	    {
	        $key[$i] = ord(substr($pwd, ($i % $pwd_length)+1, 1));
	        $counter[$i] = $i;
	    }

	    $x = 0;
	    for($i = 0; $i < 255; $i++)
	    {
	        $x = ($x + $counter[$i] + $key[$i]) % 256;
	        $temp_swap = $counter[$i];
	        $counter[$i] = isset($counter[$x]) ? $counter[$x] : 0;
	        $counter[$x] = $temp_swap;
	    }

	    $a = 0;
	    $j = 0;
	    $Zcrypt = "";
	    for($i = 0; $i < strlen($data); $i++)
	    {
	        $a = ($a + 1) % 256;
	        $j = ($j + $counter[$a]) % 256;
	        $temp = $counter[$a];
	        $counter[$a] = $counter[$j];
	        $counter[$j] = $temp;
	        $k = $counter[(($counter[$a] + $counter[$j]) % 256)];
	        $Zcipher = ord(substr($data, $i, 1)) ^ $k;
	        $Zcrypt .= chr($Zcipher);
	    }

	    return $Zcrypt;
	}

	private static function hex2bin($hexdata)
	{
	    $bindata = "";

		for($i=0,$len=strlen($hexdata); $i<$len; $i+=2)
	    {
	        $bindata .= chr(hexdec(substr($hexdata,$i,2)));
	    }

	    return $bindata;
	}
}
?>