<?php
function xml2array($url, $get_attributes=1, $priority='tag', $encoding='UTF-8')
{
	if(!function_exists('xml_parser_create'))
    {
        return array();
    }

	if(substr($url, 0, 1) == '<')
    {
    	$contents = $url;
    }
    else
    {
		$contents = '';

	    if(!($fp = @fopen($url, 'rb')))
	    {
	        return array();
	    }
	    while(!feof($fp))
	    {
	        $contents .= fread($fp, 8192);
	    }

	    fclose($fp);
    }

	$parser = xml_parser_create('');

	xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, $encoding);
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, trim($contents), $xml_values);
    xml_parser_free($parser);
    if(!$xml_values)
	{
        return array(); //Hmm...
	}

    $xml_array = array();
    $parents = array();
    $opened_tags = array();
    $arr = array();
    $current = &$xml_array;
    $repeated_tag_index = array();
    foreach($xml_values as $data)
    {
        unset($attributes, $value);
        extract($data);
        $result = array();
        $attributes_data = array();
        if(isset($value))
        {
            if($priority == 'tag')
                $result = $value;
            else
                $result['value'] = $value;
        }
        if(isset ($attributes) && $get_attributes)
        {
            foreach($attributes as $attr => $val)
            {
                if($priority == 'tag')
                    $attributes_data[$attr] = $val;
                else
                    $result['attr'][$attr] = $val; //Set all the attributes in a array called 'attr'
            }
        }
        if($type == "open")
        {
            $parent[$level -1] = & $current;
            if(!is_array($current) || (!in_array($tag, array_keys($current))))
            {
                $current[$tag] = $result;
                if($attributes_data)
                    $current[$tag . '_attr'] = $attributes_data;
                $repeated_tag_index[$tag . '_' . $level] = 1;
                $current = &$current[$tag];
            }
            else
            {
                if(isset($current[$tag][0]))
                {
                    $current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    $repeated_tag_index[$tag . '_' . $level]++;
                }
                else
                {
                    $current[$tag] = array(
                        $current[$tag],
                        $result
						);
                    $repeated_tag_index[$tag . '_' . $level] = 2;
                    if(isset($current[$tag . '_attr']))
                    {
                        $current[$tag]['0_attr'] = $current[$tag . '_attr'];
                        unset($current[$tag . '_attr']);
                    }
                }
                $last_item_index = $repeated_tag_index[$tag . '_' . $level] - 1;
                $current = &$current[$tag][$last_item_index];
            }
        }
        elseif($type == "complete")
        {
            if(!isset($current[$tag]))
            {
                $current[$tag] = $result;
                $repeated_tag_index[$tag . '_' . $level] = 1;
                if($priority == 'tag' && $attributes_data)
                    $current[$tag . '_attr'] = $attributes_data;
            }
            else
            {
                if(isset($current[$tag][0]) && is_array($current[$tag]))
                {
                    $current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    if($priority == 'tag' && $get_attributes && $attributes_data)
                    {
                        $current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                    }
                    $repeated_tag_index[$tag . '_' . $level]++;
                }
                else
                {
                    $current[$tag] = array(
                        $current[$tag],
                        $result
                    );
                    $repeated_tag_index[$tag . '_' . $level] = 1;
                    if($priority == 'tag' && $get_attributes)
                    {
                        if(isset($current[$tag . '_attr']))
                        {
                            $current[$tag]['0_attr'] = $current[$tag . '_attr'];
                            unset($current[$tag . '_attr']);
                        }
                        if($attributes_data)
                        {
                            $current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                        }
                    }
                    $repeated_tag_index[$tag . '_' . $level]++; //0 && 1 index is already taken
                }
            }
        }
        elseif($type == 'close')
        {
            $current = & $parent[$level -1];
        }
    }
    return ($xml_array);
}

function formatearxmlfile($xmlpath, $elementTag, $fieldsTags)
{
	$xmltmp = $xmlpath.'.'.date('YmdHis').'.tmp';

	if(copy($xmlpath, $xmltmp))
	{
		$xmlfp = fopen($xmltmp, 'r');
		$xmlfor = fopen($xmlpath, 'w');

		if($xmlfp !== false && $xmlfor != false)
		{
			$arrA = array();
			$arrB = array();

			$arrA[] = "<{$elementTag}>";
			$arrA[] = "</{$elementTag}>";

			$arrB[] = "<{$elementTag}>\n";
			$arrB[] = "</{$elementTag}>\n";

			foreach($fieldsTags as $fieldTag)
			{
				$arrA[] = "</{$fieldTag}>";

				$arrB[] = "</{$fieldTag}>\n";
			}

			$line = fgets($xmlfp);

			while($line !== false)
			{
				fwrite($xmlfor, str_replace($arrA, $arrB, $line));

				$line = fgets($xmlfp);
			}

			return true;
		}

		if(is_resource($xmlfp))
		{
			fclose($xmlfp);
		}

		if(is_resource($xmlfor))
		{
			fclose($xmlfor);
		}

		unlink($xmltmp);
	}

	return false;
}

function xmlfile2csvfile($xmlpath, $csvpath, $elementTag, $fieldsTags, $delimiter=',', $enclosure='"')
{
	$xmlfp = fopen($xmlpath, 'r');
	$csvfp = fopen($csvpath, 'w');

	if($xmlfp !== false && $csvfp != false)
	{
		fputcsv($csvfp, $fieldsTags, $delimiter, $enclosure);

		$elementClosed = true;
		$fieldClosed = true;
		$fieldIndex = 0;
		$fieldsCount = sizeof($fieldsTags);

		$leidas = 0;

		$data = array();
		$line = fgets($xmlfp); $leidas++;
		while($line !== false)
		{
			if($elementClosed)
			{
				if(($pos = mb_strpos($line, '<'.$elementTag.'>')) !== false)
				{
					//Msg('******Nuevo elemento******');

					$elementClosed = false;

					$line = mb_substr($line, $pos + mb_strlen('<'.$elementTag.'>'));
				}
				elseif(($pos = mb_strpos($line, '<'.$elementTag.' ')) !== false)
				{
					//Msg('******Nuevo elemento******');

					$elementClosed = false;

					$line = mb_substr($line, $pos + mb_strlen('<'.$elementTag.' '));
					$line = mb_substr($line, mb_strpos($line, '>') + 1);
				}
				else
				{
					$line = '';
				}
			}
			else
			{
				if($fieldClosed)
				{
					//Msg('------Campo cerrado------');
					//Msg('&lt;'.$fieldsTags[$fieldIndex].'&gt;');

					if(($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex].'>')) !== false)
					{
						//Etiqueta abierta normalmente
						//Msg('Etiqueta abierta normalmente');

						$fieldClosed = false;

						$line = mb_substr($line, $pos + mb_strlen('<'.$fieldsTags[$fieldIndex].'>'));
					}
					elseif(($pos = mb_strpos($line, $closeTag = '<'.$fieldsTags[$fieldIndex].'/>')) !== false || ($pos = mb_strpos($line, $closeTag = '<'.$fieldsTags[$fieldIndex].' />')) !== false)
					{
						//Etiqueta autocerrada
						//Msg('Etiqueta autocerrada');

						$data[$fieldIndex] = '';

						$line = mb_substr($line, $pos + mb_strlen($closeTag));

						$fieldIndex++;
						if($fieldIndex >= $fieldsCount)
						{
							$fieldIndex = 0;
							$elementClosed = true;

							fputcsv($csvfp, $data, $delimiter, $enclosure);

							$data = array();
							$line = '';
						}
					}
					elseif(isset($fieldsTags[$fieldIndex+1]) && (($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+1].'>')) !== false || ($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+1].'/>')) !== false || ($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+1].' />')) !== false))
					{
						//Sin Etiqueta porque encuentra la siguiente
						//Msg('No se ha encontrado (A1) la etiqueta '.$fieldsTags[$fieldIndex]);

						$data[$fieldIndex] = '';

						$fieldIndex += 1;
						if($fieldIndex >= $fieldsCount)
						{
							$fieldIndex = 0;
							$elementClosed = true;

							fputcsv($csvfp, $data, $delimiter, $enclosure);

							$data = array();
							$line = '';
						}
					}
					elseif(isset($fieldsTags[$fieldIndex+2]) && (($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+2].'>')) !== false || ($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+2].'/>')) !== false || ($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+2].' />')) !== false))
					{
						//Sin Etiqueta porque encuentra la siguiente de la siguiente
						//Msg('No se ha encontrado (A2) la etiqueta '.$fieldsTags[$fieldIndex]);

						$data[$fieldIndex] = '';
						$data[$fieldIndex + 1] = '';

						$fieldIndex += 2;
						if($fieldIndex >= $fieldsCount)
						{
							$fieldIndex = 0;
							$elementClosed = true;

							fputcsv($csvfp, $data, $delimiter, $enclosure);

							$data = array();
							$line = '';
						}
					}
					elseif(isset($fieldsTags[$fieldIndex+3]) && (($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+3].'>')) !== false || ($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+3].'/>')) !== false || ($pos = mb_strpos($line, '<'.$fieldsTags[$fieldIndex+3].' />')) !== false))
					{
						//Sin Etiqueta porque encuentra la siguiente de la siguiente de la siguiente
						//Msg('No se ha encontrado (A3) la etiqueta '.$fieldsTags[$fieldIndex]);

						$data[$fieldIndex] = '';
						$data[$fieldIndex + 1] = '';
						$data[$fieldIndex + 2] = '';

						$fieldIndex += 3;
						if($fieldIndex >= $fieldsCount)
						{
							$fieldIndex = 0;
							$elementClosed = true;

							fputcsv($csvfp, $data, $delimiter, $enclosure);

							$data = array();
							$line = '';
						}
					}
					elseif(($pos = mb_strpos($line, '</'.$elementTag.'>')) !== false)
					{
						//Sin Etiqueta porque encuentra el cierre de este elemento
						//Msg('No se ha encontrado (B) la etiqueta '.$fieldsTags[$fieldIndex]);

						for($c = $fieldIndex; $c < $fieldsCount; $c++)
						{
							$data[$c] = '';
						}

						$fieldIndex = 0;
						$elementClosed = true;

						fputcsv($csvfp, $data, $delimiter, $enclosure);

						$data = array();
						$line = '';
					}
					else
					{
						//Para que pase a la siguiente lnea
						//Msg(htmlentities($line));

						$line = '';
					}
				}
				elseif(($pos = mb_strpos($line, '</'.$fieldsTags[$fieldIndex].'>')) !== false)
				{
					//Etiqueta cerrada normalmente
					//Msg('Etiqueta cerrada normalmente');

					$data[$fieldIndex] = mb_substr($line, 0, $pos);

					$line = mb_substr($line, $pos + mb_strlen('</'.$fieldsTags[$fieldIndex].'>'));

					$fieldClosed = true;

					$fieldIndex++;
					if($fieldIndex >= $fieldsCount)
					{
						$fieldIndex = 0;
						$elementClosed = true;

						fputcsv($csvfp, $data, $delimiter, $enclosure);

						$data = array();
						$line = '';
					}
				}
				else
				{
					//No se encuentra el cierre en la misma lnea,
					//concatenamos la lnea siguiente

					$line .= "\n".fgets($xmlfp); $leidas++;
				}
			}

			if(empty($line) || !trim($line))
			{
				$line = fgets($xmlfp); $leidas++;
			}
		}

		//Msg("Lneas leidas: {$leidas}");
	}

	if(is_resource($xmlfp))
	{
		fclose($xmlfp);
	}

	if(is_resource($csvfp))
	{
		fclose($csvfp);
	}
}
/*
function Msg($str)
{
	echo $str."<br />\n";
	flush();
}
*/
function xmlfile2csvfileB($xmlpath, $csvpath, $elementTag, $fieldsTags=array(), $delimiter=',', $enclosure='"')
{
	$xmlStr = file_get_contents($xmlpath);
	$csvfp = fopen($csvpath, 'w');

	if($xmlStr !== false && $csvfp != false)
	{
		$xml = new SimpleXMLElement($xmlStr);

		if(is_array($elementTag))
		{
			$aux = $xml;
			foreach($elementTag as $tag)
			{
				$aux = $aux->$tag;
			}
		}
		else
		{
			$aux = $xml->$elementTag;
		}

		if(!is_array($fieldsTags) || empty($fieldsTags))
		{
			$fieldsTags = isset($aux[0]) && is_object($aux[0]) ? array_keys(get_object_vars($aux[0])) : array();
		}

		fputcsv($csvfp, $fieldsTags, $delimiter, $enclosure);

		foreach($aux as $item)
		{
			$data = array();
			foreach($fieldsTags as $key)
			{
				if(isset($item->$key))
				{
					$vars = get_object_vars($item->$key);
					if(empty($vars))
					{
						$data[$key] = (string)$item->$key;
					}
					else
					{
						foreach($vars as $i=>$val)
						{
							if(is_array($val))
							{
								$data[$key] = '';

								//TODO: $str podra ser otro array
								$sep = '';
								foreach($val as $str)
								{
									$data[$key] .= sprintf('%s<%s>%s</%s>', $sep, $i, $str, $i);
									$sep = "\n";
								}
							}
							else
							{
								$data[$key] = sprintf('<%s>%s</%s>', $i, $val, $i);
							}

							break; //Slo cojo el primero (no espero ms)
						}
					}
				}
				else
				{
					$data[$key] = '';
				}
			}

			fputcsv($csvfp, $data, $delimiter, $enclosure);
		}
	}

	if(is_resource($csvfp))
	{
		fclose($csvfp);
	}
}

function xmlfile2cabecera($xmlpath, $elementTag)
{
	if(($xmlStr = file_get_contents($xmlpath)) !== false)
	{
		$xml = new SimpleXMLElement($xmlStr);

		if(is_array($elementTag))
		{
			$aux = $xml;
			foreach($elementTag as $tag)
			{
				$aux = $aux->$tag;
			}
		}
		else
		{
			$aux = $xml->$elementTag;
		}

		if(isset($aux[0]) && is_object($aux[0]))
		{
			return array_keys(get_object_vars($aux[0]));
		}
	}

	return false;
}