<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {link} function plugin
 *
 * Type:     function<br />
 * Name:     link<br />
 * Purpose:  build an html link using or not short urls<br />
 * @link
 * @author José Carlos Cruz Parra AKA Internia
 * @param array
 * @param Smarty
 */
function smarty_function_link($params, &$smarty)
{
	if (empty($params['href'])) {
		$smarty->trigger_error("link: missing 'href' parameter");
		return;
	}

	$href = html_entity_decode($params['href']);

	if($params['shorturl']) {
			$indexphp_pos = strpos($href, "index.php?");
			$quest_pos = strpos($href, "?");
			$href = substr($href, 0, $indexphp_pos).substr($href, $quest_pos+1);
			$sharp_pos = strpos($href, "#");
			if($sharp_pos)
			{
				$sharp_txt = substr($href, $sharp_pos);
				$href = substr($href, 0, $sharp_pos);
			}
			$items = split("&", $href);
			$href = "";
			foreach ($items as $item) {
				$href .= substr($item, 0, strpos($item, "="))."-";
				$href .= substr($item, strpos($item, "=")+1)."-";
			}
			$href = substr($href, 0, strlen($href)-1).".html";
			if($sharp_pos)
				$href .= $sharp_txt;
	}

	$href = htmlentities($href); //TODO:
	$target = (empty($params['target']) ? "" : " target=\"{$params['target']}\"");
	$text = (empty($params['text']) ? $params['href'] : $params['text']);
	$class = (empty($params['class']) ? "" : " class=\"{$params['class']}\"");
	$title = (empty($params['title']) ? "" : " title=\"{$params['title']}\"");
	return "<a href=\"$href\"$target$class$title>$text</a>";
}

/* vim: set expandtab: */

?>
