<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty currency_format modifier plugin
 *
 * Type:     modifier<br>
 * Name:     currency_format<br>
 * Purpose:  format a number as currency in the current local format
 * @link 
 * @author   José Carlos Cruz Parra AKA Internia
 * @param int
 * @param bool
 * @param bool
 * @return string
 */
function smarty_modifier_currency_format($amount, $showcurrsymbol=true, $uselocalcurrencysymbol=true)
{
    $locale_info = localeconv();
	$number = number_format($amount,2,$locale_info["mon_decimal_point"],$locale_info["mon_thousands_sep"]);
	$curr_symbol = $uselocalcurrencysymbol ? $locale_info["currency_symbol"] : $locale_info["int_curr_symbol"];
	if($amount < 0)
	{
		//TODO: negative values,...
		if($showcurrsymbol)
		{
			if($locale_info["p_cs_precedes"])
			{
				if($locale_info["p_sep_by_space"])
					$curr_symbol .= "&nbsp;";
				return $curr_symbol.$number;
			}
			else
			{
				if($locale_info["p_sep_by_space"])
					$curr_symbol = "&nbsp;".$curr_symbol;
				return $number.$curr_symbol;
			}
		}
		return $number;
	}
	else
	{
		if($showcurrsymbol)
		{
			if($locale_info["p_cs_precedes"])
			{
				if($locale_info["p_sep_by_space"])
					$curr_symbol .= "&nbsp;";
				return $curr_symbol.$number;
			}
			else
			{
				if($locale_info["p_sep_by_space"])
					$curr_symbol = "&nbsp;".$curr_symbol;
				return $number.$curr_symbol;
			}
		}
		return $number;
	}
}

/* vim: set expandtab: */

?>
