<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty url_friendly modifier plugin
 *
 * Type:     modifier<br>
 * Name:     url_friendly<br>
 * Purpose:  prepares a string as friendly url
 * @link
 * @author   José Carlos Cruz Parra AKA Internia
 * @return string
 */
function smarty_modifier_url_friendly($str)
{
    $patrones = array();

	$patrones[] = array(array("á","à","ä","â"), "a");
	$patrones[] = array(array("é","è","ë","ê"), "e");
	$patrones[] = array(array("í","ì","ï","î"), "i");
	$patrones[] = array(array("ó","ò","ö","ô"), "o");
	$patrones[] = array(array("ú","ù","ü","û"), "u");
	$patrones[] = array('ñ', 'n');
	$patrones[] = array('€', 'E');
	$patrones[] = array('$', 'S');

	foreach($patrones as $patron)
	{
		$str = str_replace($patron[0], $patron[1], strtolower($str));
	}

	return ereg_replace('(([^0-9a-zA-Z_\.])+)', "-", $str);
}

/* vim: set expandtab: */

?>
