<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-08-02
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/faq/install.php
 *
 */

/**
 * Realiza las actuaciones particulares de la instalación de este módulo
 *
 * @param array $info
 * @return bool
 */
function faq_instalar($info)
{
	global $db;

	$ok = true;

	SWPHP::_ExecuteQuery("SET NAMES 'utf8'", "", "");

	$queries = array(
		SWPHP_DBPREFIX.'faq'=>"CREATE TABLE `".SWPHP_DBPREFIX."faq` (
		  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `pregunta` varchar(255) NOT NULL DEFAULT '',
		  `respuesta` text NOT NULL DEFAULT '',
		  `tags` varchar(255) NOT NULL DEFAULT '',
		  `fechayhoraregistro` datetime NOT NULL,
		  `fechayhoraultima` datetime NOT NULL,
		  `user_idregistro` int(10) unsigned NOT NULL,
		  `user_idultima` int(10) unsigned NOT NULL,
		  `activo` tinyint(1) unsigned NOT NULL DEFAULT '1',
		  `peso` smallint(5) NOT NULL,
		  PRIMARY KEY (`id`)
		) DEFAULT CHARSET=utf8",
		);
	foreach($queries as $key=>$query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo crear la tabla:<br /> {$key}");
	}

	return $ok;
}
/**
 * Realiza las actuaciones particulares de la desinstalación de este módulo
 *
 * @param array $info
 * @return bool
 */
function faq_desinstalar($info)
{
	global $db;

	$ok = true;

	$queries = array(
		SWPHP_DBPREFIX.'faq'=>"DROP TABLE IF EXISTS ".SWPHP_DBPREFIX."faq",
		SWPHP_DBPREFIX.'faq_idiomas'=>"DROP TABLE IF EXISTS ".SWPHP_DBPREFIX."faq_idiomas",
		);
	foreach($queries as $key=>$query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo eliminar la tabla:<br /> {$key}");
	}

	$ok &= SWPHP::_DeleteAllConfigValues('faq');

	return $ok;
}
?>