<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-06-11
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/idiomas/admin/functions.inc.php
 *
 */

/**
 * Valida los datos de un registro de idioma
 *
 * @param array $data
 * @return bool
 */
function idiomas_validarDatos($data)
{
	$ok = true;

	$requeridos = array(
		'nombre'=>'Nombre',
		'codigoiso'=>'Código ISO',
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data[$key]) || trim($data[$key]) == '')
		{
			SWPHP::_Msg("Falta el dato: {$nombre}", "error");
			$ok = false;
		}
	}

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar un idioma en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function idiomas_prepararDatos($data, $id=0)
{
	global $db;

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case "nombre":
			case "codigoiso":
			case "codigolang":
				$data[$key] = trim($value);
				break;
			case "peso":
				$data[$key] = intval($value);
				break;
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	$ahora = date('Y-m-d H:i:s');
	if($id == 0)
	{
		$data['fechayhoraregistro'] = $ahora;
		$data['user_idregistro'] = $_SESSION['user']['id'];
	}
	$data['fechayhoraultima'] = $ahora;
	$data['user_idultima'] = $_SESSION['user']['id'];

	return $data;
}
/**
 * Elimina un idioma
 *
 * @param int $id
 * @return bool
 */
function idiomas_eliminarIdioma($id)
{
	global $db;

	if($id == SWPHP_IDIOMA_POR_DEFECTO)
	{
		SWPHP::_Msg('No se puede eliminar el idioma por defecto', 'error');
	}
	else
	{
		$codigoiso = $db->GetValue('codigoiso', SWPHP_DBPREFIX.'idiomas', "WHERE id = '{$id}'", true, false);

		if(SWPHP::_OpDel(SWPHP_DBPREFIX."idiomas", $id, 'idioma'))
		{
			$antiguo = 'img/lang/'.$codigoiso.'.jpg';

			if($codigoiso && is_file($antiguo))
			{
				unlink($antiguo);
			}

			//TODO: eliminar más cosas?

			return true;
		}
	}

	return false;
}
?>