<?php
/**
 * Armando Servillera Torres
 * www.pagina-web-barata.com
 * 2012-03-20
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/admin/categorias/admin/index.php
 *
 */

$kptl_config = SWPHP::_GetConfigValues('kapitaltruth', false, 'kptl_config');

$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;
$op = isset($_GET['op']) ? $_GET['op'] : '';

if($kptl_config['habilitarkptl'] && in_array($op, array('edit', 'new', 'upd', 'reg')))
{
	$op = '';
	SWPHP::_Msg(l('No se pueden gestionar las categorías estando KPTL habilitado', 'kapitaltruth'), 'prohibido');
}

$mostrarprincipal = true;

switch($op)
{
	case "edit":
		$registro = $db->GetRow("SELECT * FROM ".SWPHP_DBPREFIX."kptl_categorias WHERE id = '{$id}'");
        if(!empty($registro['grupos']))
        {
            $registro['grupos'] = unserialize(html_entity_decode($registro['grupos']));
        }
		$registro['idiomas'] = array();
		foreach($swphp_idiomas as $idioma)
		{
			$registro['idiomas'][$idioma['id']] = $db->GetRow("SELECT texto FROM ".SWPHP_DBPREFIX."kptl_categorias_idiomas WHERE categoria_id = '{$id}' AND idioma_id = '{$idioma['id']}'");
		}

		$smarty->assign("registro", $registro);
	case "new":
        $smarty->assign('grupos', KPTL::GetGruposForHTMLSelect());
		$admin_template = "{$swphp_module_templates_dir}admin/categorias/categoria.tpl";
		$mostrarprincipal = false;

		SWPHP::_AddDocumentReady("$('.editlang').children('.lang').click(function(event){EditLangs(event);});");
		break;
	case "upd":
		if(!KPTL_ActuacionesAdmin::Act('ModCategoria', array('id'=>$id), $_POST))
		{
			$mostrarprincipal = false;
		}
		break;
	case "reg":
		if(!KPTL_ActuacionesAdmin::Act('AddCategoria', array(), $_POST))
		{
			$mostrarprincipal = false;
		}
		break;
}

if($mostrarprincipal)
{
	$paginador = SWPHP::_CrearPaginador('categorias');
	$paginador->SetParam('etiqueta', l("categoría", 'kapitaltruth'));
	$paginador->Fill("SELECT p.id, pi.texto, p.activo"
        . " FROM ".SWPHP_DBPREFIX."kptl_categorias AS p"
        . " JOIN ".SWPHP_DBPREFIX."kptl_categorias_idiomas AS pi ON p.id = pi.categoria_id AND pi.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
        .(empty($_GET['grupo_id']) ? '' : " WHERE p.porgrupos = '1' AND p.grupos LIKE '%\"".(int)$_GET['grupo_id']."\"%'")
        . " ORDER BY p.peso, p.id");

	$paginador->SetParam('campos', array(
		'id'=>array("label"=>"Id.", "class"=>"numeric", "style"=>"width:64px"),
		'texto'=>array("label"=>l('Nombre', 'kapitaltruth')),
		'activo'=>array("label"=>"", "orderby"=>false, "style"=>"width:100px"),
        ));

	$paginador->SetParam('buscador', array(
		'pi.texto'=>l('Nombre', 'kapitaltruth'),
		'p.activo'=>l('Activa', 'kapitaltruth'),
		'p.id'=>l('Id.', 'kapitaltruth'),
		'p.porgrupos'=>l('Por grupos', 'kapitaltruth'),
		));

	function applyToReg(&$reg, $key)
	{
		global $swphp_mod_clave, $kptl_config;

		$id = $reg['id'];

		if($kptl_config['habilitarkptl'])
		{
			$reg["activo"] = "<a href=\"".SWPHP_ADMIN_DIR."?mod={$swphp_mod_clave}&sub=preguntas&filtro_campo=p.categoria_id&filtro_valor={$id}&filtro_exacto=1&desde=0&por=&modo=\" title=\"Preguntas\">".SWPHP::_Icon('help.png', 16, array('alt'=>'Preguntas', 'kapitaltruth')).'</a>'
                .' '.($reg["activo"] ?
					SWPHP::_Icon("green_button.png", 16, array("alt"=>"Activada"))
					:
					SWPHP::_Icon("red_button.png", 16, array("alt"=>"Desactivada")));
		}
		else
		{
			$reg["activo"] = "<a href=\"".SWPHP_ADMIN_DIR."?mod={$swphp_mod_clave}&sub=preguntas&filtro_campo=p.categoria_id&filtro_valor={$id}&filtro_exacto=1&desde=0&por=&modo=\" title=\"Preguntas\">".SWPHP::_Icon('help.png', 16, array('alt'=>'Preguntas', 'kapitaltruth')).'</a>'
				.' '.($reg["activo"] ?
					"<a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Desactivar\">".SWPHP::_Icon("green_button.png", 16, array("alt"=>"Desactivar"))."</a>"
					:
					"<a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Activar\">".SWPHP::_Icon("red_button.png", 16, array("alt"=>"Activar"))."</a>")
				." <a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/categorias/?op=edit&amp;id={$id}\">".SWPHP::_Icon("edit.png", 16, array("alt"=>"Editar", "title"=>"Editar Id. {$id}"))."</a>"
				." <a id=\"aEliminar{$id}\" href=\"javascript:EliminarCategoria({$id})\" title=\"Eliminar\">".SWPHP::_Icon("remove.png", 16, array("alt"=>"Eliminar", "title"=>"Eliminar Id. {$id}"))."</a>";
		}
	}
	$paginador->SetParam('applyToRegs', 'applyToReg');

	$admin_template = "{$swphp_module_templates_dir}admin/categorias/categorias.tpl";

	$smarty->assign('paginador', $paginador);

	$smarty->assign("kptl_config", $kptl_config);
    $smarty->assign('grupos', KPTL::GetGruposForHTMLSelect());
}
