<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-06-25
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/menuprincipal/admin/functions.inc.php
 *
 */

/**
 * Elimina una opción y todas las que cuelguen de ella
 *
 * @param int $id
 */
function menuprincipal_eliminarOpcion($id)
{
	global $db;

	$rows = $db->GetRows("SELECT id FROM ".SWPHP_DBPREFIX."menuprincipal WHERE padre_id = '{$id}'");
	foreach($rows AS $row)
	{
		menuprincipal_eliminarOpcion($row["id"]);
	}

	if($db->Execute("DELETE FROM ".SWPHP_DBPREFIX."menuprincipal WHERE id = '{$id}'"))
	{
		$db->Execute("DELETE FROM ".SWPHP_DBPREFIX."menuprincipal_idiomas WHERE menuprincipal_id = '{$id}'");

		return true;
	}

	return false;
}
/**
 * Valida los datos de un registro del modulo
 *
 * @param array $data
 * @return bool
 */
function menuprincipal_validarDatos($data)
{
	global $swphp_idiomas;

	$ok = true;

	$requeridos = array(
		'tipo'=>'Tipo',
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data[$key]) || trim($data[$key]) == '')
		{
			SWPHP::_Msg("Falta el dato: {$nombre}", "error");
			$ok = false;
		}
	}

	if(isset($data['tipo']))
	{
		switch($data['tipo'])
		{
			case 'pagina':
				if(!isset($data['pagina_id']) || !$data['pagina_id'])
				{
					SWPHP::_Msg("Falta el dato: Página destino", "error");
					$ok = false;
				}
				break;
			case 'manual':
				$requeridos = array(
					'textoenlace'=>'Texto enlace',
					'url'=>'URL',
					);

				foreach($requeridos as $key=>$nombre)
				{
					if(!isset($data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key]) || $data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key] == '')
					{
						SWPHP::_Msg("Falta el dato: {$nombre} ({$swphp_idiomas[SWPHP_IDIOMA_POR_DEFECTO]['nombre']})", "error");
						$ok = false;
					}
				}
				break;
			default:
				SWPHP::_Msg("Valor no válido: Tipo", "error");
				$ok = false;
				break;
		}
	}

	return $ok;
}
/**
 * Prepara los datos para actualizar modulo en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function menuprincipal_prepararDatos($data, $id=0)
{
	global $db;

	$data['abriraparte'] = $data['tipo'] == 'manual' ? isset($data['abriraparte']) : 0;

	if($data['tipo'] == 'manual')
	{
		$data['pagina_id'] = 0;
	}

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'padre_id':
			case 'pagina_id':
			case 'estilo_id':
				$data[$key] = intval($value);
				break;
			case "icono":
            case "clase":
				$data[$key] = trim($value);
				break;
			case 'abriraparte':
				$data[$key] = $value ? '1' : '0';
				break;
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	$ahora = date('Y-m-d H:i:s');
	if($id == 0)
	{
		$data['fechayhoraregistro'] = $ahora;
		$data['user_idregistro'] = $_SESSION['user']['id'];
	}
	$data['fechayhoraultima'] = $ahora;
	$data['user_idultima'] = $_SESSION['user']['id'];

	return $data;
}
/**
 * Prepara los datos para insertar o actualizar datos de una página en idioma
 *
 * @param array $idiomas
 * @param int $idioma_id
 * @param int $id
 * @return array
 */
function menuprincipal_prepararDatosIdioma($idiomas, $idioma_id, $id=0)
{
	$data = SWPHP::_PrepararDatosIdioma($idiomas, $idioma_id, array('textoenlace','title','url'));

	if($id)
	{
		$data['menuprincipal_id'] = $id;
	}
	$data['idioma_id'] = $idioma_id;

	return $data;
}
?>