SET NAMES 'utf8';
CREATE TABLE IF NOT EXISTS `swphp_scu_medios` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(30) NOT NULL DEFAULT '',
  `clave` varchar(20) NOT NULL DEFAULT '',
  `activo` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `clave` (`clave`)
) DEFAULT CHARSET=utf8;
INSERT INTO `swphp_scu_medios` VALUES ('1', 'Email', 'EMAIL', '1');
INSERT INTO `swphp_scu_medios` VALUES ('2', 'SMS', 'SMS', '0');
INSERT INTO `swphp_scu_medios` VALUES ('3', 'Fax', 'FAX', '0');
CREATE TABLE IF NOT EXISTS `swphp_scu_medios_users` (
  `medio_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`medio_id`,`user_id`)
) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `swphp_scu_mensajes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `tema_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `prioridad_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `fechayhoraregistro` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `asunto` varchar(160) NOT NULL DEFAULT '',
  `textohtml` text NOT NULL,
  `textocorto` varchar(255) NOT NULL DEFAULT '',
  `manual` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `medios` varchar(32) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `swphp_scu_mensajes_users` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `mensaje_id` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `procesado` tinyint(1) NOT NULL DEFAULT '0',
  `leidoenweb` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fechayhoraproceso` datetime NOT NULL,
  `fechayhoraleido` datetime NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `swphp_scu_envios` (
  `mensaje_id` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `medio_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `resultadobool` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `resultadostring` varchar(120) NOT NULL DEFAULT '',
  `fechayhora` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `destinatario` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`mensaje_id`,`medio_id`)
) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `swphp_scu_temas` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(64) NOT NULL DEFAULT '',
  `clave` varchar(20) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `clave` (`clave`)
) DEFAULT CHARSET=utf8;
INSERT INTO `swphp_scu_temas` VALUES ('1', 'Notificaciones del administrador', 'ADMIN');
CREATE TABLE IF NOT EXISTS `swphp_scu_temas_users` (
  `tema_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`tema_id`,`user_id`)
) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `swphp_scu_prioridades` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(32) NOT NULL,
  `peso` smallint(5) NOT NULL DEFAULT '0',
  `color` varchar(12) NOT NULL DEFAULT '#ffffff',
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;
INSERT INTO `swphp_scu_prioridades` VALUES ('1', 'Baja', '400', '#0088ff');
INSERT INTO `swphp_scu_prioridades` VALUES ('2', 'Media', '300', '#e5e500');
INSERT INTO `swphp_scu_prioridades` VALUES ('3', 'Alta', '200', '#ffa000');
INSERT INTO `swphp_scu_prioridades` VALUES ('4', 'Urgente', '100', '#ff0000');