<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2010-08-31
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/usuarios/admin/functions.inc.php
 *
 */

/**
 * Valida los datos de un registro de usuario
 *
 * @param array $data
 * @param int $id
 * @return bool
 */
function usuarios_validarDatos($data, $id=0)
{
	include_once(SWPHP_COMMON_DIR."functions/validations.php");

	$ok = true;

	$requeridos = array(
		'nick'=>'Nick',
		'email'=>'Email',
		'perfil_id'=>'Perfil',
		);

	if($id == 0)
	{
		$requeridos['pass'] = 'Contraseña';
	}

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data[$key]) || $data[$key] == '')
		{
			SWPHP::_Msg("Falta el dato: {$nombre}", "error");
			$ok = false;
		}
	}

	$user = new SWPHP_User($id);

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'nick':
				if(!validateString($value, SWPHP_NICK_MINLENGTH, SWPHP_NICK_MAXLENGTH, SWPHP_NICK_VALIDCHARS))
				{
					$ok = false;
					SWPHP::_Msg('Nick no válido', 'error');
				}
				elseif($user->ExistsByField($value, 'nick', "WHERE id != '{$id}'"))
				{
					$ok = false;
					SWPHP::_Msg('Ya existe un usuario con ese nick', 'prohibido');
				}
				break;
			case 'pass':
				if($value != '')
				{
					if(!validateString($value, SWPHP_PASSWORD_MINLENGTH, SWPHP_PASSWORD_MAXLENGTH, SWPHP_PASSWORD_VALIDCHARS))
					{
						$ok = false;
						SWPHP::_Msg('Contraseña no válida', 'error');
					}
					elseif($value != $data['cpass'])
					{
						$ok = false;
						SWPHP::_Msg('No has confirmado la contraseña correctamente', 'error');
					}
				}
				break;
			case 'email':
				if(!validateEmail($value))
				{
					$ok = false;
					SWPHP::_Msg('Email no válido', 'error');
				}
				elseif($user->ExistsByField($value, 'email', "WHERE id != '{$id}'"))
				{
					$ok = false;
					SWPHP::_Msg('Ya existe un usuario con ese email', 'prohibido');
				}
				break;
			case "perfil_id":
				if(intval($value) > $_SESSION['user']['perfil_id'])
				{
					$ok = false;
					SWPHP::_Msg('Perfil no permitido', 'prohibido');
				}
				break;

			//TODO: ¿idioma_id?
		}
	}

	unset($user);

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar un usuario en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function usuarios_prepararDatos($data, $id=0)
{
	global $db;

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case "camposuser":
				//nada
				break;
			case "nick":
			case "email":
				$data[$key] = trim($value);
				break;
			case 'idioma_id':
			case "perfil_id":
				$data[$key] = intval($value);
				break;
			case "pass":
                if($value != '')
                {
                    break;
                }
                //sigue
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	return $data;
}
?>